require 'test_helper'

describe PollterGeist::ChangeListener do
  describe '#new' do
    it 'should allow empty' do
      PollterGeist::ChangeListener.new
    end
  end

  describe '#added' do
    it 'should show added messages' do
      cl = PollterGeist::ChangeListener.new
      cl.added.must_be_kind_of Array
      cl.added.must_be_empty

      cl.tick([1, 2, 3])
      cl.added.wont_be_empty
      cl.added.must_include 1
      cl.added.must_include 2
      cl.added.must_include 3
      cl.tick([1, 4])
      cl.added.size.must_equal 1
      cl.tick([])
      cl.added.must_be_empty
    end
  end

  describe '#removed' do
    it 'should show removed messages' do
      cl = PollterGeist::ChangeListener.new
      cl.removed.must_be_kind_of Array
      cl.removed.must_be_empty

      cl.tick([1, 2, 3])
      cl.removed.must_be_empty
      cl.tick([1, 4])
      cl.removed.size.must_equal 2
      cl.removed.must_include 2
      cl.removed.must_include 3
      cl.tick([])
      cl.removed.wont_be_empty
      cl.tick([])
      cl.removed.must_be_empty
    end
  end
end